#include "AgesEditorFrame.h"
#include "AgesEditorPanel.h"
#include "fileversion.h"
#include "AgesEditorScreenViewPanel.h"

BEGIN_EVENT_TABLE( AgesEditorFrame, MainFrame )
/*
	EVT_CLOSE(AgesEditorFrame::OnCloseWindow)
	EVT_MENU( wxID_EXIT, AgesEditorFrame::OnFileExit )
	EVT_MENU( wxID_SAVE, AgesEditorFrame::OnFileSave )
	EVT_MENU( wxID_SAVEAS, AgesEditorFrame::OnFileSaveAs )
	EVT_MENU( wxID_OPEN, AgesEditorFrame::OnFileOpen )
	EVT_MENU( wxID_EXIT, AgesEditorFrame::OnFileExit )
*/
	EVT_MENU( wxID_FILE1, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE2, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE3, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE4, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE5, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE6, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE7, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE8, AgesEditorFrame::OnFileOpenRecent )
	EVT_MENU( wxID_FILE9, AgesEditorFrame::OnFileOpenRecent )
END_EVENT_TABLE()

AgesEditorFrame::AgesEditorFrame( wxWindow *parent, int id )
	: MainFrame( parent, id ),
	config(wxT("OracleOfAgesEditor"),wxT("Dwedit"),wxEmptyString,wxEmptyString,wxCONFIG_USE_LOCAL_FILE)
{
	AddPanel();
	
//	history.UseMenu(fileOpenRecent);
//	history.Load(config);
	history.UseMenu(fileOpenRecent);
	history.Load(config);

	droptarget = new AgesEditorDropTarget(this);
	this->SetDropTarget(droptarget);

//	file_loaded=false;
//	file_dirty=false;

}
void AgesEditorFrame::AddPanel()
{
	wxBoxSizer* sizer = new wxBoxSizer( wxVERTICAL );
	panel = new AgesEditorPanel( this );
	sizer->Add( panel, 1, wxEXPAND );
	wxSize panelSize = panel->GetSize();
	this->SetSizerAndFit( sizer );
	this->SetClientSize( panelSize );	
}

bool AgesEditorFrame::fileLoaded() const
{
	return panel->fileLoaded();
}
bool AgesEditorFrame::fileDirty() const
{
	return panel->fileDirty();
}
wxString AgesEditorFrame::getMyFileName() const
{
	return panel->getMyFileName();
}

void AgesEditorFrame::OnFileExit( wxCommandEvent& event )
{
	Close();
}
bool AgesEditorFrame::Load(wxString FileName)
{
	if (ConfirmChangedFile())
	{
		if (panel->Load(FileName))
		{
			history.AddFileToHistory(FileName);
			return true;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}
}
bool AgesEditorFrame::Save(wxString FileName)
{
	return true;
}

bool AgesEditorFrame::openFileDialog()
{
//	wxString Filter();
	wxFileDialog *OpenDialog=new wxFileDialog(this);
	
	OpenDialog->SetWildcard(wxT("Game Boy ROM Images (*.gb;*.gbc)|*.gb;*.gbc"));
	if (OpenDialog->ShowModal()==wxID_OK)
	{
		wxString FileName=OpenDialog->GetPath();
		return Load(FileName);
	}
	return false;
}


void AgesEditorFrame::OnFileOpen( wxCommandEvent& event )
{
	openFileDialog();
}
void AgesEditorFrame::OnFileOpenRecent( wxCommandEvent& event )
{
	int myid=event.GetId();
	int myfile=myid-history.GetBaseId();
	wxString FileName= history.GetHistoryFile(myfile);
	Load(FileName);
}
void AgesEditorFrame::OnFileSave( wxCommandEvent& event )
{
	if (!fileLoaded()) return;
}
void AgesEditorFrame::OnFileSaveAs( wxCommandEvent& event )
{
	if (!fileLoaded()) return;
}

AgesEditorFrame::~AgesEditorFrame()
{
	
}

bool AgesEditorFrame::ConfirmChangedFile()
{
	if (fileLoaded() && fileDirty())
	{
		wxMessageDialog *mydialog = new wxMessageDialog(this,wxT("File has changed, save changes?"),wxMessageBoxCaptionStr,wxCENTER|wxYES_NO|wxCANCEL|wxICON_QUESTION);
		int result=mydialog->ShowModal();
		if (result==wxID_YES)
		{
			Save(getMyFileName());
		}
		if (result==wxID_NO)
		{
			return true;
		}
		return false;
	}
	else
	{
		return true;
	}
}

void AgesEditorFrame::OnCloseWindow(wxCloseEvent &event)
{
	if (ConfirmChangedFile()==false)
	{
		if (event.CanVeto())
		{
			event.Veto();
			return;
		}
	}
	history.Save(config);
	this->Destroy();
}


bool AgesEditorDropTarget::OnDropFiles(wxCoord x,wxCoord y,const wxArrayString &Files)
{
	if (Files.size()!=1) return false;
	return parent->Load(Files[0]);
}
wxDragResult AgesEditorDropTarget::OnDragOver(wxCoord x, wxCoord y, wxDragResult def)
{
	return def;
}

void AgesEditorFrame::OnViewShowAreaClass( wxCommandEvent& event )
{
	wxPanel &item=*(panel->Top_Panel);
	if (!event.IsChecked())
	{
		item.Hide();
	}
	else
	{
		item.Show();
	}
	panel->Layout();
	Layout();
	SetSize(0,0);
}

void AgesEditorFrame::HideOrShowSomething(wxPanel &item, wxCommandEvent &event)
{
	if (!event.IsChecked())
	{
		item.Hide();
	}
	else
	{
		item.Show();
	}
	panel->Layout();
}

void AgesEditorFrame::OnViewShowVram( wxCommandEvent& event )
{
	HideOrShowSomething(*panel->Vram_Column,event);
}
void AgesEditorFrame::OnViewShowTileset( wxCommandEvent& event )
{
	HideOrShowSomething(*panel->Tileset_Column,event);
}
void AgesEditorFrame::OnViewShowMap( wxCommandEvent& event )
{
	HideOrShowSomething(*panel->Map_Column,event);
}
void AgesEditorFrame::OnViewShowMinimap( wxCommandEvent& event )
{
	HideOrShowSomething(*panel->Minimap_Column,event);
}

void AgesEditorFrame::OnToolsScreenViewer( wxCommandEvent& event )
{
	ScreenViewDialog *mydialog = new ScreenViewDialog(this);
	mydialog->mypanel->app.attach(panel->app_parent);
	mydialog->mypanel->redraw_all();
//	mydialog->mypanel->Layout();
//	mydialog->Layout();
	mydialog->ShowModal();
}

wxString AgesEditorFrame::SavePNGFileDialog(wxString defaultfilename)
{
	wxFileDialog *SaveDialog=new wxFileDialog(this);
	SaveDialog->SetWildcard(wxT("PNG File (*.png)|*.png"));
	SaveDialog->SetWindowStyle(wxFD_SAVE | wxFD_CHANGE_DIR | wxFD_OVERWRITE_PROMPT );
	SaveDialog->SetFilename(defaultfilename);

	if (SaveDialog->ShowModal()==wxID_OK)
	{
		return SaveDialog->GetPath();
	}
	return wxString();
}



void AgesEditorFrame::OnExportTileset( wxCommandEvent& event )
{
	MyApp &app=panel->app;
	if (!app.romloaded()) return;
	
	wxString defaultfilename;
	if (app.whichgame==MyApp::GAME_AGES)
	{
		defaultfilename+=wxT("AGES_");
	}
	else
	{
		defaultfilename+=wxT("SEASONS_");
	}
	defaultfilename+=wxT("TILESET_");
	defaultfilename+=hex2(app.area_class_number);
	defaultfilename+=wxT(".png");

	wxString filename=SavePNGFileDialog(defaultfilename);
	if (!filename.IsEmpty())
	{
		bool retval=app.export_tileset(filename.c_str());
		if (retval==false)
		{
			wxMessageDialog msg(this,wxT("Could not save the file!"),wxMessageBoxCaptionStr,wxICON_ERROR);
			msg.ShowModal();
		}
	}
}
wxString remove_trailing_extension(const wxString &fromthis)
{
	//remove trailing extension
	int slashpos1=fromthis.find_last_of(wxT("/"));
	int slashpos2=fromthis.find_last_of(wxT("\\"));
	int slashpos=std::max(slashpos1,slashpos2);
	int dotpos=fromthis.find_last_of(wxT("."));
	if (slashpos>dotpos) dotpos=-1;
	if (dotpos!=-1)
	{
		return fromthis.substr(0,dotpos);
	}
	return fromthis;
}

void AgesEditorFrame::OnExportAllTilesets( wxCommandEvent& event )
{
	MyApp &oldapp=panel->app;
	if (!oldapp.romloaded()) return;

	MyApp app;
	app.attach(panel->app_parent);
	
	wxString defaultfilename;
	if (app.whichgame==MyApp::GAME_AGES)
	{
		defaultfilename+=wxT("AGES_");
	}
	else
	{
		defaultfilename+=wxT("SEASONS_");
	}
	defaultfilename+=wxT("TILESET_");

	wxString filename=SavePNGFileDialog(defaultfilename);
	
	if (!filename.IsEmpty())
	{
		filename=remove_trailing_extension(filename);

		bool retval=app.export_all_tilesets(filename.c_str());
		if (retval==false)
		{
			wxMessageDialog msg(this,wxT("A file failed to save, aborting operation."),wxMessageBoxCaptionStr,wxICON_ERROR);
			msg.ShowModal();
		}
	}	
}
void AgesEditorFrame::OnExportThisMap( wxCommandEvent& event )
{
	MyApp &app=panel->app;
	if (!app.romloaded()) return;
	
	wxString defaultfilename;
	if (app.whichgame==MyApp::GAME_AGES)
	{
		defaultfilename+=wxT("AGES_");
	}
	else
	{
		defaultfilename+=wxT("SEASONS_");
	}
	defaultfilename+=wxT("MAP_");
	defaultfilename+=hexn(panel->my_plane,2);
	defaultfilename+=wxT("_");
	defaultfilename+=hexn(app.map_number,2);
	defaultfilename+=wxT(".png");

	wxString filename=SavePNGFileDialog(defaultfilename);
	if (!filename.IsEmpty())
	{
		bool retval=app.export_map(filename.c_str());
		if (retval==false)
		{
			wxMessageDialog msg(this,wxT("Could not save the file!"),wxMessageBoxCaptionStr,wxICON_ERROR);
			msg.ShowModal();
		}
	}
}
void AgesEditorFrame::OnExportThisPlane( wxCommandEvent& event )
{
	int myplane=panel->my_plane;
	MyApp &oldapp=panel->app;
	if (!oldapp.romloaded()) return;
	MyApp app;
	app.attach(panel->app_parent);
	
	wxString defaultfilename;
	if (app.whichgame==MyApp::GAME_AGES)
	{
		defaultfilename+=wxT("AGES_");
	}
	else
	{
		defaultfilename+=wxT("SEASONS_");
	}
	defaultfilename+=wxT("PLANE_");
	defaultfilename+=hexn(myplane,2);
	defaultfilename+=wxT(".png");

	wxString filename=SavePNGFileDialog(defaultfilename);
	if (!filename.IsEmpty())
	{
		bool retval=app.export_plane(filename.c_str(),myplane);
		if (retval==false)
		{
			wxMessageDialog msg(this,wxT("Could not save the file!"),wxMessageBoxCaptionStr,wxICON_ERROR);
			msg.ShowModal();
		}
	}
	
}
void AgesEditorFrame::OnExportAllPlanes( wxCommandEvent& event )
{
	MyApp &oldapp=panel->app;
	if (!oldapp.romloaded()) return;

	MyApp app;
	app.attach(panel->app_parent);
	
	wxString defaultfilename;
	if (app.whichgame==MyApp::GAME_AGES)
	{
		defaultfilename+=wxT("AGES_");
	}
	else
	{
		defaultfilename+=wxT("SEASONS_");
	}
	defaultfilename+=wxT("PLANE_");
	wxString filename=SavePNGFileDialog(defaultfilename);
	
	if (!filename.IsEmpty())
	{
		filename=remove_trailing_extension(filename);
		
		bool retval=app.export_all_planes(filename.c_str());
		if (retval==false)
		{
			wxMessageDialog msg(this,wxT("A file failed to save, aborting operation."),wxMessageBoxCaptionStr,wxICON_ERROR);
			msg.ShowModal();
		}
	}	
}
