#ifndef AGESEDITORFRAME_H
#define AGESEDITORFRAME_H

#include "AgesEditor_GUI.h"
#include "AgesEditorPanel.h"
#include <wx/docview.h>
#include <wx/dnd.h>
#include <wx/config.h>

class AgesEditorFrame;

class AgesEditorDropTarget : public wxFileDropTarget
{
public:
	AgesEditorFrame *parent;
	AgesEditorDropTarget(AgesEditorFrame *newparent)
	{
		parent=newparent;
	}
	bool OnDropFiles(wxCoord x,wxCoord y,const wxArrayString &Files);
	wxDragResult OnDragOver(wxCoord x, wxCoord y, wxDragResult def);
};

class AgesEditorFrame : public MainFrame
{
public:
	AgesEditorFrame( wxWindow *parent = NULL, int id = -1 );
	~AgesEditorFrame();

	void OnFileExit( wxCommandEvent& event );
	void OnHelpAbout( wxCommandEvent& event );
	void OnFileOpen( wxCommandEvent& event );
	void OnFileOpenRecent( wxCommandEvent& event );
	void OnFileSave( wxCommandEvent& event );
	void OnFileSaveAs( wxCommandEvent& event );
	void OnCloseWindow( wxCloseEvent &event);
	void AddPanel();
	void HideOrShowSomething(wxPanel &item, wxCommandEvent &event);
	void OnViewShowAreaClass( wxCommandEvent& event );
	void OnViewShowVram( wxCommandEvent& event );
	void OnViewShowTileset( wxCommandEvent& event );
	void OnViewShowMap( wxCommandEvent& event );
	void OnViewShowMinimap( wxCommandEvent& event );
	void OnToolsScreenViewer( wxCommandEvent& event );

	void OnExportTileset( wxCommandEvent& event );
	void OnExportAllTilesets( wxCommandEvent& event );
	void OnExportThisMap( wxCommandEvent& event );
	void OnExportThisPlane( wxCommandEvent& event );
	void OnExportAllPlanes( wxCommandEvent& event );

	wxString SavePNGFileDialog(wxString defaultfilename=wxString());

public:
	bool fileLoaded() const;
	bool fileDirty() const;
	wxString getMyFileName() const;
	
	bool openFileDialog();
	bool ConfirmChangedFile();
	bool Load(wxString FileName);
	bool Save(wxString FileName);

	AgesEditorPanel* panel;
	AgesEditorDropTarget *droptarget;

	wxFileHistory history;
	wxConfig config;

	DECLARE_EVENT_TABLE();
};
#endif // AGESEDITORFRAME_H
