#ifndef AGESEDITORPANEL_H
#define AGESEDITORPANEL_H

#pragma once

#include "AgesEditor_GUI.h"
#include "MyApp.h"
#include "BackedPanel.h"
#include "bitmap.h"

class AgesEditorPanel : public MainPanel
{
public:
	AgesEditorPanel( wxWindow* parent );
	~AgesEditorPanel();
	bool Load(wxString FileName);
	bool Save(wxString FileName);
	bool fileLoaded() const;
	bool fileDirty() const;
	wxString getMyFileName() const;
	void draw_map();
	void create_minimaps();
	void draw_minimap();
	void draw_vram();
	void draw_tileset();
	void draw_palette();
	void redraw_all();
	void update_info_text();
	void OnMapKeyDown(wxKeyEvent &event);
	void OnPaint(wxPaintEvent &event);
	void OnAreaClassSpin(wxSpinEvent &event);
	void OnPaletteSpin(wxSpinEvent &event);
	void OnVramSpin(wxSpinEvent &event);
	void OnVram2Spin(wxSpinEvent &event);
	void OnVram3Spin(wxSpinEvent &event);
	void OnTilesetSpin(wxSpinEvent &event);
	void OnSeasonSpin(wxSpinEvent &event);
	void OnAdd2Click(wxCommandEvent &event);
	void OnMinimapMouse(wxMouseEvent &event);
	void OnMinimapKeyDown(wxKeyEvent &event);
	void OnPlaneSelection(wxCommandEvent &event);
	void NewMap(int x, int y, int plane, bool add2, int season);
	void NewAreaClassNumber();
	void NewPaletteNumber(int number);
	void NewVramNumber(int number);
	void NewVram2Number(int number);
	void NewVram3Number(int number);
	void NewTilesetNumber(int number);
	void NewSeasonNumber(int number);
	void UpdatePlaneList(MyApp::Whichgame_t whichgame);
public:
	MyAppParent app_parent;
	MyApp app;
	wxString myfilename;
	vector<wxBitmap> minimaps;
	bool filedirty;
	int my_x,my_y,my_plane;
	int my_season;
	bool my_add2;
	//state information
	u32 vram_hash;
	u64 tileset_hash;
//	u64 map_hash;
	int palette_palette;
	void invalidate_state();

private:
	DECLARE_EVENT_TABLE();
};


#endif //AGESEDITORPANEL_H