﻿#include "AgesEditorScreenViewPanel.h"
#include "BackedPanel.h"
#include "GUI_common.h"

void AgesEditorScreenViewPanel::redraw_all()
{
	draw_palette();
	draw_vram();
	draw_map();
}

void AgesEditorScreenViewPanel::draw_vram()
{
	if (!app.romloaded()) return;
	if (vram_vram==my_vram) return;
	vram_vram=my_vram;
	app.load_vram_packets(my_vram,0,255);
	app.render_tiles();

	::draw_vram(app.tiles,vrampanel->mybitmap,true);
	vrampanel->Refresh();
}
void AgesEditorScreenViewPanel::draw_map()
{
	if (!app.romloaded()) return;
	if (map_vram==my_vram && map_map==my_map && map_palette==my_palette) return;
	map_vram=my_vram;
	map_map=my_map;
	map_palette=my_palette;
	draw_palette();
	draw_vram();
	
	if (my_map!=my_vram)
	{
		app.load_vram_packets(my_map,0,255);
	}
	
	
	CBP map1=app.ram(0,0x9800);
	CBP map2=app.ram(0,0x9C00);
	::draw_screen(app.rgbpalette,app.tiles,map1,map1panel->mybitmap);
	::draw_screen(app.rgbpalette,app.tiles,map2,map2panel->mybitmap);
	map1panel->Refresh();
	map2panel->Refresh();

	if (my_map!=my_vram)
	{
		app.load_vram_packets(my_vram,0,255);
	}



}
void AgesEditorScreenViewPanel::draw_palette()
{
	if (!app.romloaded()) return;
	if (palette_palette==my_palette) return;
	palette_palette=my_palette;
	app.clear_palette();
	app.load_palette(my_palette,true);
	app.palette_number=my_palette;
	app.rgbpalette_palette=-1;
	app.render_palette();

	::draw_palette(app.rgbpalette,palettepanel->mybitmap);
	palettepanel->Refresh();
}

void AgesEditorScreenViewPanel::OnPaletteSpin( wxSpinEvent& event )
{
	my_palette=event.GetInt();
	redraw_all();
}

void AgesEditorScreenViewPanel::OnVramSpin( wxSpinEvent& event )
{
	my_vram=event.GetInt();
	if (checklinked->GetValue())
	{
		my_map=my_vram;
		mapspin->SetValue(my_vram);
	}
	redraw_all();
}
void AgesEditorScreenViewPanel::OnMapSpin( wxSpinEvent& event )
{
	my_map=event.GetInt();
	if (checklinked->GetValue())
	{
		my_vram=my_map;
		vramspin->SetValue(my_vram);
	}
	redraw_all();
}
void AgesEditorScreenViewPanel::OnLinkCheck( wxCommandEvent& event )
{
	if (event.GetSelection())
	{
		my_map=my_vram;
		mapspin->SetValue(my_vram);
	}
	redraw_all();
}