﻿#ifndef __AgesEditorScreenViewPanel__
#define __AgesEditorScreenViewPanel__

#pragma once

#include "AgesEditor_GUI.h"
#include "MyApp.h"

class AgesEditorScreenViewPanel : public ScreenViewPanel
{
public:
	AgesEditorScreenViewPanel( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxSize( 660,353 ), long style = wxTAB_TRAVERSAL )
		: ScreenViewPanel(parent,id,pos,size,style)
	{
		my_vram=0;
		my_map=0;
		my_palette=0;
		invalidate_state();
	}
	void invalidate_state()
	{
		vram_vram=-1;
		map_vram=-1;
		map_map=-1;
		map_palette=-1;
		palette_palette=-1;
	}
	MyApp app;
	void redraw_all();
	void draw_vram();
	void draw_map();
	void draw_palette();
	
	void OnPaletteSpin( wxSpinEvent& event );
	void OnVramSpin( wxSpinEvent& event );
	void OnMapSpin( wxSpinEvent& event );
	void OnLinkCheck( wxCommandEvent& event );

	int my_vram,my_map,my_palette;
	int vram_vram,map_vram,map_map,map_palette,palette_palette;
};

#endif // __AgesEditorScreenViewPanel__
